#!/bin/bash 
##############################################################################
#
# $Id: pmountd_nanny.sh,v 1.1 2010/08/12 20:59:19 litvinse Exp $ 
#
# script that monitors pmountd and starts it if it is missing
#
##############################################################################
setup=/usr/etc/pnfsSetup
if [ ! -f $setup ] ; then
   echo " Sorry, can't find $setup "
   exit 1
fi
. $setup
tools=$pnfs/tools
. $tools/special

pid=`spps | $AWK '{ if(($NF=="pmountd"))printf "%s ",$1; }'`
if [ -z $pid ]
then
    enstore alarm  --raise --client-name PMOUNTD_NANNY --severity W --root-error "PMOUNTD GONE" --message "pmountd not running, restarting "
    $tools/pnfs.server start pmountd 
fi